# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      requests_method.py
# Author:       xxxxxxx
# Datetime:     2023/8/7 19:12
# Description:
# 
# ---------------------------------------------------------------------------
import base64

import requests

from APIAutoTest_004.common.read_ini import ReadIni


class RequestsMethod:
    def __init__(self):
        url = ReadIni().get_host("bpm_url") + "/auth"
        data = {"username": "admin", "password": base64.b64encode("123456".encode("utf-8")).decode("utf-8")}
        self.bpm_session = requests.sessions.Session()
        token = self.bpm_session.request(method="post", url=url, json=data).json().get("token")
        self.bpm_session.headers["Authorization"] = "Bearer " + token

    def request_all(self, method, url, mime, case_data):
        if mime == "application/x-www-form-urlencoded" or mime == "x-www-form-urlencoded":
            return self.bpm_session.request(method=method, url=url, data=case_data)

        elif mime == "application/json" or mime == "json":
            return self.bpm_session.request(method=method, url=url, json=case_data)

        elif mime == "multipart/form-data" or mime == "form-data":
            return self.bpm_session.request(method=method, url=url, files=case_data)

        elif mime == "query" or mime == "params":
            return self.bpm_session.request(method=method, url=url, params=case_data)

        elif mime == "query|json" or mime == "json|query":
            return self.bpm_session.request(method=method, url=url, params=case_data["query"], json=case_data["body"])

        elif mime == "text/plain":
            return self.bpm_session.request(method=method, url=url, data=case_data)

        elif mime is None:
            return self.bpm_session.request(method=method, url=url)

        else:
            raise NameError("传参错误！！！")





if __name__ == '__main__':
    req = RequestsMethod()