# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023/8/7 19:35
# Description:
# 
# ---------------------------------------------------------------------------
import logging
import allure
import pytest

from APIAutoTest_004.common.read_excel import ReadExcel


class TestBPM:
    @allure.epic("BPM")
    @pytest.mark.parametrize("module, interface, title, level, method, url, mime, case_data, expect_data, sql_type,sql_sentence,update_key", ReadExcel().get_data())
    def test_bpm(self, req_fix, db_fix, module, interface, title, level, method, url, mime, case_data, expect_data, sql_type,sql_sentence,update_key):
        allure.dynamic.feature(module)
        allure.dynamic.story(interface)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)

        if sql_type == "delete":
            db_fix.delete(sql_sentence)

        elif sql_type == "select":
            sql_result = db_fix.select(sql_sentence)
            case_data[update_key] = sql_result

        elif sql_type == "delete|select" or sql_type == "select|delete":
            db_fix.delete(sql_sentence["delete"])
            sql_sentence = db_fix.select(sql_sentence["select"])
            case_data[update_key] = sql_sentence

        result = req_fix.request_all(method=method, url=url, mime=mime, case_data=case_data)
        try:
            for key in expect_data:
                assert result.json().get(key) == expect_data[key]
        except:
            print("断言失败")
            logging.error("断言失败，模块名称为：{}，接口名称为：{}，标题为：{}，用例数据为：{}".format(module, interface, title, case_data))
            raise AssertionError("断言失败咯")
        else:
            print("断言成功")


if __name__ == '__main__':
    pytest.main()

